﻿B4J=true
Group=Pages
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Static code module
#IgnoreWarnings:12
Sub Process_Globals
	Public Vue As BANanoVue
	Private BANano As BANano  'ignore
	Private app As BANanoElement
End Sub

Sub Init
	'initialize vue, this clears the body and adds an empty div identified with app.
	app = Vue.Initialize
	'set the font family
	Vue.SetFontFamily($"'Ubuntu', sans-serif"$)
	'set the default state
	Dim state As Map = CreateMap()
	state.Put("greeting", "Hello World!")
	state.Put("user", "The Mash")
	state.Put("city","East London, South Africa")
	Vue.SetDefaultState(state)
	
	'let's update the app div
	app.Append($"<h2>{{ greeting }}</h2>"$)
	app.Append($"<p>by {{ user }} who lives in {{ city }}</p>"$)
	'
	Dim btn1 As VueButton
	btn1.Initialize(Vue, "btn1").SetOnClick(Me, "changeGreeting").SetText("Change Greeting").Render("#app") 
		
	'execute the DOM rendering
	Vue.ux
End Sub

Sub changeGreeting(e As BANanoEvent)
	'get current greeting
	Dim greeting As String = Vue.GetState("greeting")
	'toggle the state
	greeting = BANano.IIf(greeting = "Hello World!", "What's Up", "Hello World!")
	'update the state
	Vue.SetState(CreateMap("greeting":greeting))
End Sub
